/* netToe v 1.0.5
 * Release date: 06 June January 2000
 * Copyright 2000 Gabriele Giorgetti <g.gabriele@europe.com>
 *		
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "game.h"
#include "misc.h"
#include "netmisc.h"

int main (void)
{
  main_menu ();
  quit_game ();
}

void print_header (void)
{
  system("clear");
  printf ("+-----------------------------------------------------------+\n");
  printf ("| netToe v%s ------------------ The Net Tic Tac Toe Game |\n", PRG_VERSION);
  printf ("+-----------------------------------------------------------+\n");
}

void main_menu (void)
{
  int selection;

  print_header ();
  printf ("\n       [Main Menu]\n\n");
  printf ("    1. Player VS CPU\n");
  printf ("    2. Player VS Player\n");
  printf ("    3. Two players over network\n");
  printf ("    4. Infos\n");
  printf ("    5. Quit\n");
  printf ("\n Selection: ");
  scanf ("%d", &selection);

  if (selection == 1)
    {
      get_cpu_AI ();

      who_starts = who_start_first ();

      printf ("\n Player 1 please type your name: ");
      scanf ("%s", &player1_name);
      if (who_starts == 1)
	{
	  printf ("\n Who will start first ? (random selection)\n");
	  printf ("\n %s will start first !\n", player1_name);
	  sleep ( 2 );
	}
      else if (who_starts == 2)
	{
	  printf ("\n Who will start first ? (random selection)\n");
	  printf ("\n Computer will start first !\n");
	  sleep ( 2 );
	}
      init_1_player_game ();
    }
  else if (selection == 2)
    {
      print_header ();
      who_starts = who_start_first ();
      printf ("\n Player 1 please type your name: ");
      scanf ("%s", &player1_name);
      printf ("\n Player 2 please type your name: ");
      scanf ("%s", &player2_name);
      if (who_starts == 1)
	{
	  printf ("\n Who will start first ? (random selection)\n");
	  printf ("\n %s will start first !\n", player1_name);
	  sleep ( 2 );
	}
      else if (who_starts == 2)
	{
	  printf ("\n Who will start first ? (random selection)\n");
	  printf ("\n %s will start first !\n", player2_name);
	  sleep ( 2 );
	}

      init_2_player_game ();
    }
  else if (selection == 3)
    {
      network_options ();
    }
  else if (selection == 4)
    {
      print_header ();
      print_infos_screen ();
      exit(0);
    }

  else if (selection == 5)
    {
      quit_game ();
    }
  else
    {
      printf ("\nError: wrong selection\n");
      quit_game ();
    }
}

void init_matrix (void)
{
  c11 = ' ', c12 = ' ', c13 = ' ';
  c21 = ' ', c22 = ' ', c23 = ' ';
  c31 = ' ', c32 = ' ', c33 = ' ';
}

void init_1_player_game (void)
{
  char y_n[2];
  winner = 0;
  game_mode = 1;
  init_matrix ();

  if (who_starts == 1)
    {
      do
	{
	  who_starts = 2;
	  show_game ();
	  get_player1_move ();
	  show_game ();
	  winner = game_check ();
	  if (winner == 1)
	    break;
	  else if (winner == 3)
	    break;
	  if (computer_AI == 1)
	    {
	      get_cpu_normal_move ();
	    }
	  else if (computer_AI == 2)
	    {
	      get_cpu_hard_move ();
	    }


	  show_game ();
	  winner = game_check ();
	  if (winner == 2)
	    break;
	  else if (winner == 3)
	    break;
	}
      while (winner == 0);
    }
  else if (who_starts == 2)
    {
      do
	{
	  who_starts = 1;
	  show_game ();
	  if (computer_AI == 1)
	    {
	      get_cpu_normal_move ();
	    }
	  else if (computer_AI == 2)
	    {
	      get_cpu_hard_move ();
	    }

	  show_game ();
	  winner = game_check ();
	  if (winner == 2)
	    break;
	  else if (winner == 3)
	    break;
	  get_player1_move ();
	  show_game ();
	  winner = game_check ();
	  if (winner == 1)
	    break;
	  else if (winner == 3)
	    break;
	}
      while (winner == 0);
    }
  if (winner == 1)
    {
      printf ("\n%s wins !\n\n", player1_name);
      player1_status++;
      printf ("do you want to play again ? [y/n]: ");
      scanf ("%s", &y_n);
      if (!strcmp (y_n, "y"))
	{
	  init_1_player_game ();
	}
      else if (!strcmp (y_n, "n"))
	{
	  main_menu ();
	}
      else
	{
	  printf ("wrong answer I suppose you want to play again...\n");
	  sleep ( 2 );
	  init_1_player_game ();
	}
    }
  else if (winner == 2)
    {
      printf ("\nComputer wins !\n\n");
      computer_status++;
      printf ("do you want to play again ? [y/n]: ");
      scanf ("%s", &y_n);
      if (!strcmp (y_n, "y"))
	{
	  init_1_player_game ();
	}
      else if (!strcmp (y_n, "n"))
	{
	  main_menu ();
	}
      else
	{
	  printf ("wrong answer I suppose you want to play again...\n");
	  sleep ( 2 );
	  init_1_player_game ();
	}
    }
  else if (winner == 3)
    {
      printf ("\nThere is no winner !\n\n");
      printf ("do you want to play again ? [y/n]: ");
      scanf ("%s", &y_n);
      if (!strcmp (y_n, "y"))
	{
	  init_1_player_game ();
	}
      else if (!strcmp (y_n, "n"))
	{
	  main_menu ();
	}
      else
	{
	  printf ("wrong answer I suppose you want to play again...\n");
	  sleep ( 2 );
	  init_1_player_game ();
	}
    }
}

void init_2_player_game (void)
{
  char y_n[2];
  winner = 0;
  game_mode = 2;
  init_matrix ();

  if (who_starts == 1)
    {
      do
	{
	  who_starts = 2;
	  show_game ();
	  get_player1_move ();
	  show_game ();
	  winner = game_check ();
	  if (winner == 1)
	    break;
	  else if (winner == 3)
	    break;
	  get_player2_move ();
	  show_game ();
	  winner = game_check ();
	  if (winner == 2)
	  break;
	  else if (winner == 3)
	  break;
	}
      while (winner == 0);
    }
  else if (who_starts == 2)
    {
      do
	{
	  who_starts = 1;
	  show_game ();
	  get_player2_move ();
	  show_game ();
	  winner = game_check ();
	  if (winner == 2)
	    break;
	  if (winner == 3)
	    break;
	  get_player1_move ();
	  show_game ();
	  winner = game_check ();
	  if (winner == 1)
	    break;
	  if (winner == 3)
	    break;
	}
      while (winner == 0);
    }

  if (winner == 1)
    {
      printf ("\n%s wins !\n\n", player1_name);
      player1_status++;
      printf ("do you want to play again ? [y/n]: ");
      scanf ("%s", &y_n);
      if (!strcmp (y_n, "y"))
	{
	  init_2_player_game ();
	}
      else if (!strcmp (y_n, "n"))
	{
	  main_menu ();
	}
      else
	{
	  printf ("wrong answer I suppose you want to play again...\n");
	  sleep ( 2 );
	  init_2_player_game ();
	}
    }

  if (winner == 2)
    {
      printf ("\n%s wins !\n\n", player2_name);
      player2_status++;
      printf ("do you want to play again ? [y/n]: ");
      scanf ("%s", &y_n);
      if (!strcmp (y_n, "y"))
	{
	  init_2_player_game ();
	}
      else if (!strcmp (y_n, "n"))
	{
	  main_menu ();
	}
      else
	{
	  printf ("wrong answer I suppose you want to play again...\n");
	  sleep ( 2 );
	  init_2_player_game ();
	}
    }
  else if (winner == 3)
    {
      printf ("\nThere is no winner !\n\n");
      printf ("do you want to play again ? [y/n]: ");
      scanf ("%s", &y_n);
      if (!strcmp (y_n, "y"))
	{
	  init_2_player_game ();
	}
      else if (!strcmp (y_n, "n"))
	{
	  main_menu ();
	}
      else
	{
	  printf ("wrong answer I suppose you want to play again...\n");
	  sleep ( 2 );
	  init_1_player_game ();
	}
    }
}

void show_game (void)
{
  print_header ();
  printf ("    Current Game           |      Coordinates scheme\n");
  printf ("                           |                        \n");
  printf ("       |   |               |            |    |    \n");
  printf ("     %c | %c | %c             |         a1 | a2 | a3 \n", c11, c12, c13);
  printf ("    ---|---|---            |        ----|----|---- \n");
  printf ("     %c | %c | %c             |         b1 | b2 | b3 \n", c21, c22, c23);
  printf ("    ---|---|---            |        ----|----|---- \n");
  printf ("     %c | %c | %c             |         c1 | c2 | c3 \n", c31, c32, c33);
  printf ("       |   |               |            |    |    \n");

  if (game_mode == 1)
    {
      printf ("+---------------------------------------------------------+\n");
      printf (" %s: %d Computer: %d\n", player1_name, player1_status, computer_status);
      printf ("+---------------------------------------------------------+\n");
    }
  else if (game_mode == 2)
    {
      printf ("+---------------------------------------------------------+\n");
      printf (" %s: %d %s: %d\n", player1_name, player1_status, player2_name, player2_status);
      printf ("+---------------------------------------------------------+\n");
    }
  else if (game_mode == 3)
    {
      printf ("+---------------------------------------------------------+\n");
      printf (" %s: %d %s: %d\n", player1_name, player1_status, player2_name, player2_status);
      printf ("+---------------------------------------------------------+\n");
    }
}


void get_player1_move (void)
{
  char p1move[4];

  printf ("\n%s, it's your turn: ", player1_name);
  scanf ("%s", p1move);
  if (!strcmp (p1move, "a1"))
    {
      if (c11 == ' ')
	{
	  c11 = 'X';
	}
      else if (c11 != ' ')
	{
	  get_player1_move ();
	}
    }
  else if (!strcmp (p1move, "a2"))
    {
      if (c12 == ' ')
	{
	  c12 = 'X';
	}
      else if (c12 != ' ')
	{
	  get_player1_move ();
	}
    }
  else if (!strcmp (p1move, "a3"))
    {
      if (c13 == ' ')
	{
	  c13 = 'X';
	}
      else if (c13 != ' ')
	{
	  get_player1_move ();
	}
    }
  else if (!strcmp (p1move, "b1"))
    {
      if (c21 == ' ')
	{
	  c21 = 'X';
	}
      else if (c21 != ' ')
	{
	  get_player1_move ();
	}
    }
  else if (!strcmp (p1move, "b2"))
    {
      if (c22 == ' ')
	{
	  c22 = 'X';
	}
      else if (c22 != ' ')
	{
	  get_player1_move ();
	}
    }
  else if (!strcmp (p1move, "b3"))
    {
      if (c23 == ' ')
	{
	  c23 = 'X';
	}
      else if (c23 != ' ')
	{
	  get_player1_move ();
	}
    }
  else if (!strcmp (p1move, "c1"))
    {
      if (c31 == ' ')
	{
	  c31 = 'X';
	}
      else if (c31 != ' ')
	{
	  get_player1_move ();
	}
    }
  else if (!strcmp (p1move, "c2"))
    {
      if (c32 == ' ')
	{
	  c32 = 'X';
	}
      else if (c32 != ' ')
	{
	  get_player1_move ();
	}
    }
  else if (!strcmp (p1move, "c3"))
    {
      if (c33 == ' ')
	{
	  c33 = 'X';
	}
      else if (c33 != ' ')
	{
	  get_player1_move ();
	}
    }
  else
    {
      get_player1_move ();
    }
}

void get_player2_move (void)
{
  char p2move[4];

  printf ("\n%s, it's your turn: ", player2_name);
  scanf ("%s", p2move);
  if (!strcmp (p2move, "a1"))
    {
      if (c11 == ' ')
	{
	  c11 = '0';
	}
      else if (c11 != ' ')
	{
	  get_player2_move ();
	}
    }
  else if (!strcmp (p2move, "a2"))
    {
      if (c12 == ' ')
	{
	  c12 = '0';
	}
      else if (c12 != ' ')
	{
	  get_player2_move ();
	}
    }
  else if (!strcmp (p2move, "a3"))
    {
      if (c13 == ' ')
	{
	  c13 = '0';
	}
      else if (c13 != ' ')
	{
	  get_player2_move ();
	}
    }
  else if (!strcmp (p2move, "b1"))
    {
      if (c21 == ' ')
	{
	  c21 = '0';
	}
      else if (c21 != ' ')
	{
	  get_player2_move ();
	}
    }
  else if (!strcmp (p2move, "b2"))
    {
      if (c22 == ' ')
	{
	  c22 = '0';
	}
      else if (c22 != ' ')
	{
	  get_player2_move ();
	}
    }
  else if (!strcmp (p2move, "b3"))
    {
      if (c23 == ' ')
	{
	  c23 = '0';
	}
      else if (c23 != ' ')
	{
	  get_player2_move ();
	}
    }
  else if (!strcmp (p2move, "c1"))
    {
      if (c31 == ' ')
	{
	  c31 = '0';
	}
      else if (c31 != ' ')
	{
	  get_player2_move ();
	}
    }
  else if (!strcmp (p2move, "c2"))
    {
      if (c32 == ' ')
	{
	  c32 = '0';
	}
      else if (c32 != ' ')
	{
	  get_player2_move ();
	}
    }
  else if (!strcmp (p2move, "c3"))
    {
      if (c33 == ' ')
	{
	  c33 = '0';
	}
      else if (c33 != ' ')
	{
	  get_player2_move ();
	}
    }
  else
    {
      get_player2_move ();
    }
}

void get_cpu_AI (void)
{
  int selection;
  print_header ();
  printf ("\n   [Select AI level]\n\n");
  printf ("     1. Normal \n");
  printf ("     2. Hard   \n");
  printf ("\n Selection: ");
  scanf ("%d", &selection);
  if (selection == 1)
    {
      computer_AI = 1;
    }
  else if (selection == 2)
    {
      computer_AI = 2;
    }
    
  else 
    {
      get_cpu_AI();
    }
}

void get_cpu_normal_move (void)
{
  printf ("\nComputer turn...\n");
  sleep ( 1 );

  if ((c11 == 'X') & (c12 == 'X') & (c13 == ' '))
    {
      c13 = '0';
      return;
    }
  else if ((c33 == 'X') & (c32 == 'X') & (c31 == ' '))
    {
      c31 = '0';
      return;
    }
  else if ((c11 == 'X') & (c21 == 'X') & (c31 == ' '))
    {
      c31 = '0';
      return;
    }
  else if ((c13 == 'X') & (c23 == 'X') & (c33 == ' '))
    {
      c33 = '0';
      return;
    }
  else if ((c13 == 'X') & (c22 == 'X') & (c31 == ' '))
    {
      c31 = '0';
      return;
    }
  else if ((c21 == 'X') & (c22 == 'X') & (c23 == ' '))
    {
      c23 = '0';
      return;
    }
  else if ((c23 == 'X') & (c22 == 'X') & (c21 == ' '))
    {
      c21 = '0';
      return;
    }
  else if ((c11 == 'X') & (c13 == 'X') & (c12 == ' '))
    {
      c12 = '0';
      return;
    }
  else if (c22 == ' ')
    {
      c22 = '0';
      return;
    }
  else if (c31 == ' ')
    {
      c31 = '0';
      return;
    }
  else if ((c31 == '0') & (c22 == '0') & (c13 == ' '))
    {
      c13 = '0';
      return;
    }
  else if (c12 == ' ')
    {
      c12 = '0';
      return;
    }

  else if ((c22 == '0') & (c11 == ' ') & (c33 == '0'))
    {
      c11 = '0';
      return;
    }
  else if ((c32 == '0') & (c22 == '0') & (c12 == ' '))
    {
      c12 = '0';
      return;
    }
  else if ((c12 == '0') & (c22 == '0') & (c32 == ' '))
    {
      c32 = '0';
      return;
    }
  else if (c33 == ' ')
    {
      c33 = '0';
      return;
    }
  else if (c23 == ' ')
    {
      c23 = '0';
      return;
    }
  else if (c21 == ' ')
    {
      c21 = '0';
      return;
    }
  else if (c13 == ' ')
    {
      c13 = '0';
      return;
    }
  else if (c11 == ' ')
    {
      c11 = '0';
      return;
    }
  else if (c32 == ' ')
    {
      c32 = '0';
      return;
    }
}

void get_cpu_hard_move (void)
{
  printf ("\nComputer turn...\n");
  sleep ( 1 );

  if ((c11 == 'X') & (c12 == 'X') & (c13 == ' '))
    {
      c13 = '0';
      return;
    }
  else if ((c33 == 'X') & (c32 == 'X') & (c31 == ' '))
    {
      c31 = '0';
      return;
    }
  else if ((c11 == 'X') & (c21 == 'X') & (c31 == ' '))
    {
      c31 = '0';
      return;
    }
  else if ((c13 == 'X') & (c23 == 'X') & (c33 == ' '))
    {
      c33 = '0';
      return;
    }
  else if ((c13 == 'X') & (c22 == 'X') & (c31 == ' '))
    {
      c31 = '0';
      return;
    }
  else if ((c21 == 'X') & (c22 == 'X') & (c23 == ' '))
    {
      c23 = '0';
      return;
    }
  else if ((c23 == 'X') & (c22 == 'X') & (c21 == ' '))
    {
      c21 = '0';
      return;
    }
  else if ((c11 == 'X') & (c13 == 'X') & (c12 == ' '))
    {
      c12 = '0';
      return;
    }
  else if ((c22 == 'X') & (c32 == ' ') & (c12 == 'X'))
    {
      c32 = '0';
      return;
    }
  else if (( c22 == ' ') & (c33 == ' '))
    {
      c22 = '0';
    }
  else if ((c22 == '0') & (c11 == '0') & (c33 == ' '))
    {
      c33 = '0';
    }
  else if ((c33 == ' ') & (c22 == ' '))
    {
      c22 = '0';
    }
  else if ((c31 == '0') & (c33 == '0') & (c32 == ' '))
    {
      c32 = '0';
    }
  else if ((c23 == '0') & (c22 == '0') & (c21 == ' '))
    {
      c21 = '0';
    }
  else if ((c12 == '0') & (c22 == '0') & (c32 == ' '))
    {
      c32 = '0';
    }
  else if ((c11 == '0') & (c33 == '0') & (c22 == ' '))
    {
    	c22 = '0';
    }		
  else if (c31 == ' ')
    {
      c31 = '0';
      return;
    }
  else if ((c31 == '0') & (c22 == '0') & (c13 == ' '))
    {
      c13 = '0';
      return;
    }
  else if (c12 == ' ')
    {
      c12 = '0';
      return;
    }

  else if ((c22 == '0') & (c11 == ' ') & (c33 == '0'))
    {
      c11 = '0';
      return;
    }
  else if ((c32 == '0') & (c22 == '0') & (c12 == ' '))
    {
      c12 = '0';
      return;
    }
  else if ((c12 == '0') & (c22 == '0') & (c32 == ' '))
    {
      c32 = '0';
      return;
    }
  else if (c33 == ' ')
    {
      c33 = '0';
      return;
    }
  else if (c23 == ' ')
    {
      c23 = '0';
      return;
    }
  else if (c21 == ' ')
    {
      c21 = '0';
      return;
    }
  else if (c13 == ' ')
    {
      c13 = '0';
      return;
    }
  else if (c11 == ' ')
    {
      c11 = '0';
      return;
    }
  else if (c32 == ' ')
    {
      c32 = '0';
      return;
    }
}

int game_check (void)
{

  if ((c11 == 'X') & (c12 == 'X') & (c13 == 'X'))
    {
      return 1;
    }
  if ((c21 == 'X') & (c22 == 'X') & (c23 == 'X'))
    {
      return 1;
    }
  if ((c31 == 'X') & (c32 == 'X') & (c33 == 'X'))
    {
      return 1;
    }

  if ((c11 == 'X') & (c21 == 'X') & (c31 == 'X'))
    {
      return 1;
    }
  if ((c12 == 'X') & (c22 == 'X') & (c32 == 'X'))
    {
      return 1;
    }
  if ((c13 == 'X') & (c23 == 'X') & (c33 == 'X'))
    {
      return 1;
    }

  if ((c11 == 'X') & (c22 == 'X') & (c33 == 'X'))
    {
      return 1;
    }
  if ((c13 == 'X') & (c22 == 'X') & (c31 == 'X'))
    {
      return 1;
    }

  if ((c11 == '0') & (c12 == '0') & (c13 == '0'))
    {
      return 2;
    }
  if ((c21 == '0') & (c22 == '0') & (c23 == '0'))
    {
      return 2;
    }
  if ((c31 == '0') & (c32 == '0') & (c33 == '0'))
    {
      return 2;
    }

  if ((c11 == '0') & (c21 == '0') & (c31 == '0'))
    {
      return 2;
    }
  if ((c12 == '0') & (c22 == '0') & (c32 == '0'))
    {
      return 2;
    }
  if ((c13 == '0') & (c23 == '0') & (c33 == '0'))
    {
      return 2;
    }

  if ((c11 == '0') & (c22 == '0') & (c33 == '0'))
    {
      return 2;
    }
  if ((c13 == '0') & (c22 == '0') & (c31 == '0'))
    {
      return 2;
    }

  if ((c11 != ' ') && (c12 != ' ') && (c13 != ' ') && (c21 != ' ') && (c22 != ' ') && (c23 != ' ') && (c31 != ' ') && (c32 != ' ') & (c33 != ' '))
    {
      return 3;
    }
}

void network_options (void)
{
  int selection;

  print_header ();
  printf ("\n   [Network game options]\n\n");
  printf ("     1. Host the game\n");
  printf ("     2. Connect to a host\n");
  printf ("     3. Back to main menu\n");
  printf ("\n Selection: ");
  scanf ("%d", &selection);

  if (selection == 1)
    {
      server_start ();
    }
  else if (selection == 2)
    {
      client_start ();
    }
  else if (selection == 3)
    {
      main_menu ();
    }
  else
    {
      printf ("\nError: wrong selection\n");
      sleep ( 2 );
      network_options ();
    }
}

int server_start (void)
{
  int transf_bytes;
  char buf[MAXDATASIZE];
  char local_ip_address[20];
  char peer_ip_address[20];

  print_header ();
  printf ("\n   [Host the game]\n\n");
  printf ("    Player name: ");
  scanf ("%s", player1_name);
  strcpy (local_ip_address, give_local_IP ());
  printf ("    You should now tell your IP address to the 2nd player\n");
  printf ("\n   Connected players:\n");
  printf ("   ------------------\n");
  printf ("   - %s (you)\n", player1_name);

  server_write_sock = establish_listening_socket (SERVER_PORT_NUMBER, peer_ip_address);
  transf_bytes = write_to_socket (server_write_sock, player1_name, 20);

  sleep ( 2 );

  server_read_sock = connect_to_socket (peer_ip_address, CLIENT_PORT_NUMBER);

  transf_bytes = read (server_read_sock, player2_name, 20);
  printf ("   - %s (player 2)\n", player2_name);

  printf ("\n   found 2 players, starting game...\n");
  sleep ( 3 );

  print_header ();
  printf ("\n   Who will start first ? (random selection)\n\n");

  who_starts = who_start_first ();

  if (who_starts == 1)
    {
      printf ("   %s will start first !\n", player1_name);
      transf_bytes = write_to_socket (server_write_sock, player1_name, 20);
    }

  else if (who_starts == 2)
    {
      printf ("   %s will start first !\n", player2_name);
      transf_bytes = write_to_socket (server_write_sock, player2_name, 20);
    }

  printf ("\n   Starting game...\n");
  sleep ( 2 );

  init_server_network_game ();

}

void client_start (void)
{
  int transf_bytes;
  char buf[MAXDATASIZE];
  char host_ip_number[20];
  char peer_ip_address[20];

  print_header ();
  printf ("\n   [Connect to a host]\n\n");
  printf ("    Player name: ");
  scanf ("%s", player2_name);
  printf ("    Host IP address: ");
  scanf ("%s", &host_ip_number);
  printf ("\n   Connecting....\n");
  printf ("   -------------------------\n");

  client_read_sock = connect_to_socket (host_ip_number, SERVER_PORT_NUMBER);

  printf ("   connected ! players are:\n\n");
  transf_bytes = read_from_socket (client_read_sock, player1_name, 20);

  printf ("   -%s (player1)\n", player1_name);
  printf ("   -%s (you)\n", player2_name);

  client_write_sock = establish_listening_socket (CLIENT_PORT_NUMBER, peer_ip_address);
  transf_bytes = write_to_socket (client_write_sock, player2_name, 20);

  printf ("\n   found 2 players, starting game...\n");
  sleep ( 3 );

  print_header ();
  printf ("\n   Who will start first ? (random selection)\n\n");

  transf_bytes = read_from_socket (client_read_sock, buf, 20);
  printf ("   %s will start first !\n", buf);
  printf ("\n   Starting game...\n");
  sleep ( 2 );

  init_client_network_game ();

}

void init_server_network_game (void)
{
  char y_n[2];
  char yes_no[2];
  int transf_bytes;
  char buf[MAXDATASIZE];
  char move_done[2];

  game_mode = 3;

  init_matrix ();

  if (who_starts == 1)
    {	
      transf_bytes = write_to_socket (server_write_sock, "1", 1);
    }
  else if (who_starts == 2)
    {	
      transf_bytes = write_to_socket (server_write_sock, "2", 1);
    }

  if (who_starts == 1)
    {
      do
	{
	  who_starts = 2;
	  show_game ();
	  get_player1_move ();
	  show_game ();
	  transf_bytes = write_to_socket (server_write_sock, move_done, 2);
	  net_game_send_server_matrix ();
	  transf_bytes = write_to_socket (server_write_sock, move_done, 2);
	  winner = game_check ();
	  if (winner == 1)
	    {
	      show_game ();
	      break;
	    }
	  if (winner == 2)
	    {
	      show_game ();
	      break;
	    }
	  if (winner == 3)
	    {
	      show_game ();
	      break;
	    }
	  printf ("\nwaiting for %s's move...\n", player2_name);
	  for (move_done[2] = 'y'; strcmp (buf, move_done);)
	    transf_bytes = read_from_socket (server_read_sock, buf, 2);
	  net_game_recv_server_matrix ();
	  move_done[20] = 'n';
	  for (move_done[2] = 'y'; strcmp (buf, move_done);)
	    transf_bytes = read_from_socket (server_read_sock, buf, 2);
	  winner = game_check ();
	  if (winner == 1)
	    {
	      show_game ();
	      break;
	    }
	  if (winner == 2)
	    {
	      show_game ();
	      break;
	    }
	  if (winner == 3)
	    {
	      show_game ();
	      break;
	    }
	}
      while (winner == 0);
    }

  else if (who_starts == 2)
    {
      do
	{
	  who_starts = 1;
	  show_game ();
	  printf ("\nwaiting for %s's move...\n", player2_name);
	  for (move_done[2] = 'y'; strcmp (buf, move_done);)
	    transf_bytes = read_from_socket (server_read_sock, buf, 2);
	  net_game_recv_server_matrix ();
	  move_done[20] = 'n';
	  for (move_done[2] = 'y'; strcmp (buf, move_done);)
	    transf_bytes = read_from_socket (server_read_sock, buf, 2);
	  show_game ();
	  winner = game_check ();
	  if (winner == 1)
	    {
	      show_game ();
	      break;
	    }
	  if (winner == 2)
	    {
	      show_game ();
	      break;
	    }
	  if (winner == 3)
	    {
	      show_game ();
	      break;
	    }
	  get_player1_move ();
	  show_game ();
	  transf_bytes = write_to_socket (server_write_sock, move_done, 2);
	  net_game_send_server_matrix ();
	  transf_bytes = write_to_socket (server_write_sock, move_done, 2);
	  winner = game_check ();
	  if (winner == 1)
	    {
	      show_game ();
	      break;
	    }
	  if (winner == 2)
	    {
	      show_game ();
	      break;
	    }
	  if (winner == 3)
	    {
	      show_game ();
	      break;
	    }
	}
      while (winner == 0);
    }
  if (winner == 1)
    {
      printf ("\n%s wins !\n\n", player1_name);
      player1_status++;
      printf ("do you want to play again ? [y/n]: ");
      scanf ("%s", &y_n);
      if (!strcmp (y_n, "y"))
	{
	  transf_bytes = write_to_socket (server_write_sock, move_done, 2);
	  transf_bytes = write_to_socket (server_write_sock, "y", 2);
	  printf ("Waiting for %s to choose if play again or not...\n",
		  player2_name);
	  for (move_done[2] = 'y'; strcmp (buf, move_done);)
	    transf_bytes = read_from_socket (server_read_sock, buf, 2);
	  transf_bytes = read_from_socket (server_read_sock, yes_no, 2);
	  if (!strcmp (yes_no, "y"))
	    {
	      printf ("\n%s wants to play again.\n", player2_name);
	      printf ("Starting...\n");
	      sleep ( 4 );
	      init_server_network_game ();
	    }
	}
      else if (!strcmp (y_n, "n"))
	{
	  transf_bytes = write_to_socket (server_write_sock, move_done, 2);
	  transf_bytes = write_to_socket (server_write_sock, "n", 2);
	  sleep ( 2 );
	  quit_game ();
	}
      else
	{
	  printf ("wrong answer I suppose you want to play again...\n");
	  sleep ( 2 );
	  transf_bytes = write_to_socket (server_write_sock, move_done, 2);
	  transf_bytes = write_to_socket (server_write_sock, "y", 2);
	  printf ("Waiting for %s to choose if play again or not...\n", player2_name);
	  for (move_done[2] = 'y'; strcmp (buf, move_done);)
	    transf_bytes = read_from_socket (server_read_sock, buf, 2);
	  transf_bytes = read_from_socket (server_read_sock, yes_no, 2);
	  if (!strcmp (yes_no, "y"))
	    {
	      printf ("\n%s wants to play again.\n", player2_name);
	      printf ("Starting...\n");
	      sleep ( 4 );
	      init_server_network_game ();
	    }	
	}
    }

  if (winner == 2)
    {
      printf ("\n%s wins !\n\n", player2_name);
      player2_status++;
      printf ("do you want to play again ? [y/n]: ");
      scanf ("%s", &y_n);
      if (!strcmp (y_n, "y"))
	{
	  transf_bytes = write_to_socket (server_write_sock, move_done, 2);
	  transf_bytes = write_to_socket (server_write_sock, "y", 2);
	  printf ("Waiting for %s to choose if play again or not...\n",
		  player2_name);
	  for (move_done[2] = 'y'; strcmp (buf, move_done);)
	    transf_bytes = read_from_socket (server_read_sock, buf, 2);
	  transf_bytes = read_from_socket (server_read_sock, yes_no, 2);
	  if (!strcmp (yes_no, "y"))
	    {
	      printf ("\n%s wants to play again.\n", player2_name);
	      printf ("Starting...\n");
	      sleep ( 4 );
	      init_server_network_game ();
	    }
	}
      else if (!strcmp (y_n, "n"))
	{
	  transf_bytes = write_to_socket (server_write_sock, move_done, 2);
	  transf_bytes = write_to_socket (server_write_sock, "n", 2);
	  sleep ( 3 );
	  quit_game ();
	}
      else
	{
	  printf ("wrong answer I suppose you want to play again...\n");	
	  sleep ( 2 );
	  transf_bytes = write_to_socket (server_write_sock, move_done, 2);
	  transf_bytes = write_to_socket (server_write_sock, "y", 2);
	  printf ("Waiting for %s to choose if play again or not...\n", player2_name);
	  for (move_done[2] = 'y'; strcmp (buf, move_done);)
	    transf_bytes = read_from_socket (server_read_sock, buf, 2);
	  transf_bytes = read_from_socket (server_read_sock, yes_no, 2);
	  if (!strcmp (yes_no, "y"))
	    {
	      printf ("\n%s wants to play again.\n", player2_name);
	      printf ("Starting...\n");
	      sleep ( 4 );
	      init_server_network_game ();
	    }	
	}
    }
  else if (winner == 3)
    {
      printf ("\nThere is no winner !\n\n");
      printf ("do you want to play again ? [y/n]: ");
      scanf ("%s", &y_n);
      if (!strcmp (y_n, "y"))
	{
	  transf_bytes = write_to_socket (server_write_sock, move_done, 2);
	  transf_bytes = write_to_socket (server_write_sock, "y", 2);
	  printf ("Waiting for %s to choose if play again or not...\n", player2_name);
	  for (move_done[2] = 'y'; strcmp (buf, move_done);)
	    transf_bytes = read_from_socket (server_read_sock, buf, 2);
	  transf_bytes = read_from_socket (server_read_sock, yes_no, 2);
	  if (!strcmp (yes_no, "y"))
	    {
	      printf ("\n%s wants to play again.\n", player2_name);
	      printf ("Starting...\n");
	      sleep ( 4 );
	      init_server_network_game ();
	    }
	}
      else if (!strcmp (y_n, "n"))
	{
	  transf_bytes = write_to_socket (server_write_sock, move_done, 2);
	  transf_bytes = write_to_socket (server_write_sock, "n", 2);
	  sleep ( 2 );
	  quit_game ();
	}
      else
	{
	  printf ("wrong answer I suppose you want to play again...\n");
	  sleep ( 2 );
	  transf_bytes = write_to_socket (server_write_sock, move_done, 2);
	  transf_bytes = write_to_socket (server_write_sock, "y", 2);
	  printf ("Waiting for %s to choose if play again or not...\n", player2_name);
	  for (move_done[2] = 'y'; strcmp (buf, move_done);)
	    transf_bytes = read_from_socket (server_read_sock, buf, 2);
	  transf_bytes = read_from_socket (server_read_sock, yes_no, 2);
	  if (!strcmp (yes_no, "y"))
	    {
	      printf ("\n%s wants to play again.\n", player2_name);
	      printf ("Starting...\n");
	      sleep ( 4 );
	      init_server_network_game ();
	    }	
	}
    }

  quit_game ();
}

void init_client_network_game (void)
{
  char y_n[2];
  char yes_no[2];
  int transf_bytes;
  char buf[MAXDATASIZE];
  char move_done[2];

  game_mode = 3;
  init_matrix ();

  transf_bytes = read_from_socket (client_read_sock, buf, 1);

  if (!strcmp (buf, "1"))
    {				
      who_starts = 1;
    }
  else if (!strcmp (buf, "2"))
    {				
      who_starts = 2;
    }

  if (who_starts == 1)
    {
      do
	{
	  who_starts = 2;
	  show_game ();
	  printf ("\nwaiting for %s's move...\n", player1_name);
	  for (move_done[2] = 'y'; strcmp (buf, move_done);)
	    transf_bytes = read_from_socket (client_read_sock, buf, 2);
	  net_game_recv_client_matrix ();
	  move_done[20] = 'n';
	  for (move_done[2] = 'y'; strcmp (buf, move_done);)
	    transf_bytes = read_from_socket (client_read_sock, buf, 2);
	  show_game ();
	  winner = game_check ();
	  if (winner == 1)
	    {
	      show_game ();
	      break;
	    }
	  if (winner == 2)
	    {
	      show_game ();
	      break;
	    }
	  if (winner == 3)
	    {
	      show_game ();
	      break;
	    }
	  get_player2_move ();
	  show_game ();
	  transf_bytes = write_to_socket (client_write_sock, move_done, 2);
	  net_game_send_client_matrix ();
	  transf_bytes = write_to_socket (client_write_sock, move_done, 2);
	  winner = game_check ();
	  if (winner == 1)
	    {
	      show_game ();
	      break;
	    }
	  if (winner == 2)
	    {
	      show_game ();
	      break;
	    }
	  if (winner == 3)
	    {
	      show_game ();
	      break;
	    }
	}
      while (winner == 0);
    }

  else if (who_starts == 2)
    {
      do
	{
	  who_starts = 1;
	  show_game ();
	  get_player2_move ();
	  show_game ();
	  transf_bytes = write_to_socket (client_write_sock, move_done, 2);
	  net_game_send_client_matrix ();
	  transf_bytes = write_to_socket (client_write_sock, move_done, 2);
	  winner = game_check ();
	  if (winner == 1)
	    {
	      show_game ();
	      break;
	    }
	  if (winner == 2)
	    {
	      show_game ();
	      break;
	    }
	  if (winner == 3)
	    {
	      show_game ();
	      break;
	    }
	  printf ("\nwaiting for %s's move...\n", player2_name);
	  for (move_done[2] = 'y'; strcmp (buf, move_done);)
	    transf_bytes = read_from_socket (client_read_sock, buf, 2);
	  net_game_recv_client_matrix ();
	  move_done[20] = 'n';
	  for (move_done[2] = 'y'; strcmp (buf, move_done);)
	    transf_bytes = read_from_socket (client_read_sock, buf, 2);
	  winner = game_check ();
	  if (winner == 1)
	    {
	      show_game ();
	      break;
	    }
	  if (winner == 2)
	    {
	      show_game ();
	      break;
	    }
	  if (winner == 3)
	    {
	      show_game ();
	      break;
	    }
	}
      while (winner == 0);
    }
  if (winner == 1)
    {
      printf ("\n%s wins !\n\n", player1_name);
      player1_status++;
      printf ("waiting for %s to choose if to play again or not...\n", player1_name);
      for (move_done[2] = 'y'; strcmp (buf, move_done);)
	transf_bytes = read_from_socket (client_read_sock, buf, 2);
      transf_bytes = read_from_socket (client_read_sock, yes_no, 2);
      if (!strcmp (yes_no, "y"))
	{
	  printf ("\n%s wants to play again. What about you ?\n", player1_name);
	  printf ("do you want to play again ? [y/n]: ");
	  scanf ("%s", &y_n);

	  if (!strcmp (y_n, "y"))
	    {
	      transf_bytes = write_to_socket (client_write_sock, move_done, 2);
	      transf_bytes = write_to_socket (client_write_sock, "y", 2);
	      printf ("Starting...\n");
	      sleep ( 4 );
	      init_client_network_game ();
	    }
	}
      else if (!strcmp (yes_no, "n"))
	{
	  printf ("\n%s doesn't want to play again. Sorry.\n", player1_name);
	  sleep ( 3 );
	  close (client_read_sock);
	  close (client_write_sock);
	  exit (0);
	}
      else {
	     printf ("wrong answer I suppose you want to play again...\n");
             sleep ( 2 );
             transf_bytes = write_to_socket (client_write_sock, move_done, 2);
	     transf_bytes = write_to_socket (client_write_sock, "y", 2);
	     printf ("Starting...\n");
	     sleep ( 4 );
	     init_client_network_game ();
           }
    }

  if (winner == 2)
    {
      printf ("\n%s wins !\n\n", player2_name);
      player2_status++;
      printf ("waiting for %s to choose if to play again or not...\n", player1_name);
      for (move_done[2] = 'y'; strcmp (buf, move_done);)
      transf_bytes = read_from_socket (client_read_sock, buf, 2);
      transf_bytes = read_from_socket (client_read_sock, yes_no, 2);
      if (!strcmp (yes_no, "y"))
	{
	  printf ("\n%s wants to play again. What about you ?\n", player1_name);
	  printf ("do you want to play again ? [y/n]: ");
	  scanf ("%s", &y_n);

	  if (!strcmp (y_n, "y"))
	    {
	      transf_bytes = write_to_socket (client_write_sock, move_done, 2);
	      transf_bytes = write_to_socket (client_write_sock, "y", 2);
	      printf ("Starting...\n");
	      sleep ( 4 );
	      init_client_network_game ();
	    }
	}
      else if (!strcmp (yes_no, "n"))
	{
	  printf ("\n%s doesn't want to play again. Sorry.\n", player1_name);
	  sleep ( 3 );
	  quit_game ();
	}
      else {
	     printf ("wrong answer I suppose you want to play again...\n");
             sleep ( 2 );
             transf_bytes = write_to_socket (client_write_sock, move_done, 2);
	     transf_bytes = write_to_socket (client_write_sock, "y", 2);
	     printf ("Starting...\n");
	     sleep ( 4 );
	     init_client_network_game ();
           }
    }
  else if (winner == 3)
    {
      printf ("\nThere is no winner !\n\n");
      printf ("waiting for %s to choose if to play again or not...\n", player1_name);
      for (move_done[2] = 'y'; strcmp (buf, move_done);)
      transf_bytes = read_from_socket (client_read_sock, buf, 2);
      transf_bytes = read_from_socket (client_read_sock, yes_no, 2);
      if (!strcmp (yes_no, "y"))
	{
	  printf ("\n%s wants to play again. What about you ?\n", player1_name);
	  printf ("do you want to play again ? [y/n]: ");
	  scanf ("%s", &y_n);

	  if (!strcmp (y_n, "y"))
	    {
	      transf_bytes = write_to_socket (client_write_sock, move_done, 2);
	      transf_bytes = write_to_socket (client_write_sock, "y", 2);
	      printf ("Starting...\n");
	      sleep ( 4 );
	      init_client_network_game ();
	    }
	}
      else if (!strcmp (yes_no, "n"))
	{
	  printf ("\n%s doesn't want to play again. Sorry.\n", player1_name);
	  sleep ( 3 );
          quit_game ();
	}
     else {
	     printf ("wrong answer I suppose you want to play again...\n");
             sleep ( 2 );
             transf_bytes = write_to_socket (client_write_sock, move_done, 2);
	     transf_bytes = write_to_socket (client_write_sock, "y", 2);
	     printf ("Starting...\n");
	     sleep ( 4 );
	     init_client_network_game ();
           }
      quit_game ();
    }
}

net_game_send_server_matrix ()
{
  int transf_bytes;
  transf_bytes = write_to_socket (server_write_sock, &c11, 1);
  transf_bytes = write_to_socket (server_write_sock, &c12, 1);
  transf_bytes = write_to_socket (server_write_sock, &c13, 1);
  transf_bytes = write_to_socket (server_write_sock, &c21, 1);
  transf_bytes = write_to_socket (server_write_sock, &c22, 1);
  transf_bytes = write_to_socket (server_write_sock, &c23, 1);
  transf_bytes = write_to_socket (server_write_sock, &c31, 1);
  transf_bytes = write_to_socket (server_write_sock, &c32, 1);
  transf_bytes = write_to_socket (server_write_sock, &c33, 1);
}

net_game_recv_server_matrix ()
{
  int transf_bytes;
  transf_bytes = read_from_socket (server_read_sock, &c11, 1);
  transf_bytes = read_from_socket (server_read_sock, &c12, 1);
  transf_bytes = read_from_socket (server_read_sock, &c13, 1);
  transf_bytes = read_from_socket (server_read_sock, &c21, 1);
  transf_bytes = read_from_socket (server_read_sock, &c22, 1);
  transf_bytes = read_from_socket (server_read_sock, &c23, 1);
  transf_bytes = read_from_socket (server_read_sock, &c31, 1);
  transf_bytes = read_from_socket (server_read_sock, &c32, 1);
  transf_bytes = read_from_socket (server_read_sock, &c33, 1);
}

net_game_send_client_matrix ()
{
  int transf_bytes;
  transf_bytes = write_to_socket (client_write_sock, &c11, 1);
  transf_bytes = write_to_socket (client_write_sock, &c12, 1);
  transf_bytes = write_to_socket (client_write_sock, &c13, 1);
  transf_bytes = write_to_socket (client_write_sock, &c21, 1);
  transf_bytes = write_to_socket (client_write_sock, &c22, 1);
  transf_bytes = write_to_socket (client_write_sock, &c23, 1);
  transf_bytes = write_to_socket (client_write_sock, &c31, 1);
  transf_bytes = write_to_socket (client_write_sock, &c32, 1);
  transf_bytes = write_to_socket (client_write_sock, &c33, 1);
}

net_game_recv_client_matrix ()
{
  int transf_bytes;
  transf_bytes = read_from_socket (client_read_sock, &c11, 1);
  transf_bytes = read_from_socket (client_read_sock, &c12, 1);
  transf_bytes = read_from_socket (client_read_sock, &c13, 1);
  transf_bytes = read_from_socket (client_read_sock, &c21, 1);
  transf_bytes = read_from_socket (client_read_sock, &c22, 1);
  transf_bytes = read_from_socket (client_read_sock, &c23, 1);
  transf_bytes = read_from_socket (client_read_sock, &c31, 1);
  transf_bytes = read_from_socket (client_read_sock, &c32, 1);
  transf_bytes = read_from_socket (client_read_sock, &c33, 1);

}

void quit_game (void)
{
  printf("\nGoodbye !\n\n");
  printf("netToe Copyright 2000 Gabriele Giorgetti <g.gabriele@europe.com>\n");
  printf("netToe project page is at: http://nettoe.sourceforge.net\n\n");
  close (server_read_sock);
  close (server_write_sock);
  close (client_read_sock);
  close (client_write_sock);
  exit (0);
}


