extern int buildPasswd(int passwdType, int passwdLen,
                       int hand, char *pwString_ptr);
/* 

Using the buildPasswd() function:

The first parameter, "passwdType" defines what characters you would like to
include in your random string. It is an integer with the sum of one or more
of the following:

	1 - Lowercase alphabetical characters
	2 - Uppercase alphabetical characters
	4 - Numerical characters
	8 - Non-alphanumeric printable characters

Example: If you wanted "passwdType to return a string consisting of lowercase
alphabetical characters and numbers you would give passwdType a value of 5.


The second parameter, "passwdLen" is an integer defining the desired length
of the password.

The third parameter "hand" determines which hand to use to type the password.
A value of zero does nothing. A value of 1 generates a password that can be
typed entirely with the left hand, a value of 2 will generate a password that
can be typed entirely with the right hand. A value of 3 will generate a 
password that will alternate between the left and right hands.

The final parameter is the address in memory of the first entry in the
character array that will store the generated password.

*/

struct passwdOptions {
  int type;
  int length;
  int hand;
};
